import 'package:librus_api/librus_api_base.dart';
import 'package:librus_api/models/resource.dart';
import 'package:librus_api/models/subject.dart';
import 'package:reflectable/mirrors.dart';

@reflector
class Grade extends Resource {
  static String get collection => "Grades";

  static String get entry => "Grades";
  String grade;
  int id;
  dynamic lesson;
  dynamic subject;
  dynamic student;
  dynamic category;
  dynamic addedBy;
  String date;
  String addDate;
  dynamic comments;
  bool isConstituent;
  bool isSemester;
  bool isSemesterProposition;
  bool isFinal;
  bool isFinalProposition;
  int semester;
  dynamic improvement;
  dynamic resit;

  static Grade fromJson(dynamic data) {
    try {
      Grade item = new Grade();
      InstanceMirror im = reflector.reflect(item);
      data.forEach((key, value) => im.invokeSetter(key, value));
      return item;
    } catch (err, stacktrace) {
      print(err);
      print(stacktrace);
    }
    return null;
  }
}
