import 'package:librus_api/librus_api_base.dart';
import 'package:librus_api/models/grade.dart';
import 'package:librus_api/models/resource.dart';
import 'package:reflectable/mirrors.dart';

@reflector
class Subject extends Resource {
  static String get collection => "Subjects";

  static String get entry => "Subjects";
  int id;
  int no;
  String name;
  String short;
  bool isExtracurricular;
  bool isBlockLesson;
  List<Grade> grades = [];

  static Subject fromJson(dynamic data) {
    try {
      Subject item = new Subject();
      InstanceMirror im = reflector.reflect(item);
      data.forEach((key, value) => im.invokeSetter(key, value));
      return item;
    } catch (err, stacktrace) {
      print(err);
      print(stacktrace);
    }
    return null;
  }
}
