import 'dart:convert';
import 'dart:io';

import 'package:librus_api/librus_api.dart';
import 'package:librus_api/librus_api_base.dart';
import 'package:librus_api/models/grade.dart';

main() async {
  var api = LibrusApi('./cookies');
  await api.signIn(Platform.environment['LIBRUS_USERNAME'], Platform.environment['LIBRUS_PASSWORD']);
  var accounts = await api.accounts;
  await accounts[0].refresh();
  accounts[0].grades = await accounts[0].fetch<Grade>(() => new Grade());
  print(json.encode(api));
}
