import 'package:librus_api/librus_api_base.dart';
import 'package:librus_api/models/resource.dart';
import 'package:reflectable/mirrors.dart';

@reflector
class Category extends Resource {
  static String get collection => "Grades/Categories";

  static String get entry => "Categories";
  String name;
  bool adultsExtramural;
  bool adultsDaily;
  bool standard;
  bool countToTheAverage;
  bool blockAnyGrades;
  bool obligationToPerform;
  int weight;
  int id;
  dynamic color;

  static Category fromJson(dynamic data) {
    try {
      Category item = new Category();
      InstanceMirror im = reflector.reflect(item);
      data.forEach((key, value) => im.invokeSetter(key, value));
      return item;
    } catch (err, stacktrace) {
      print(err);
      print(stacktrace);
    }
    return null;
  }
}
